import axios from 'axios';

var api = function api(baseUrl) {
    var create = axios.create({
        baseURL: baseUrl,
        withCredentials: true
    });

    create.interceptors.request.use(function (request) {
        return request;
    }, function (error) {
        error.msg = 'Erro ao tentar enviar dados.';
        console.error(error.msg, error, error.request);
        return Promise.reject(error);
    });

    create.interceptors.response.use(function (response) {
        return response;
    }, function (error) {
        var response = error.response;
        error.msg = response && response.data ? response.data.msg : 'Erro ao tentar receber dados.';
        console.error(error.msg, error, error.response);
        return Promise.reject(error);
    });

    return create;
};

// const api = {
//     apiGeral: apiGenerico(API_URL)
// };

export default api;