import React from 'react';
import PropTypes from 'prop-types';
import { withStyles, createStyleSheet } from 'material-ui/styles';
import Typography from 'material-ui/Typography';

var styleSheet = createStyleSheet({
  row: {
    display: 'flex',
    justifyContent: 'left'
  },
  avatar: {
    backgroundColor: '#fff',
    backgroundSize: 'cover',
    backgroundPosition: 'center',
    borderRadius: '50%'
  },
  avatarText: {
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    height: '100%',
    fontSize: '200%'
  }
});

var ImageAvatars = function ImageAvatars(_ref) {
  var size = _ref.size,
      src = _ref.src,
      alt = _ref.alt,
      classes = _ref.classes,
      children = _ref.children;

  return React.createElement(
    'div',
    { className: classes.row },
    React.createElement(
      'div',
      {
        alt: alt,
        style: { backgroundImage: 'url(' + src + ')', width: size, height: size },
        className: classes.avatar
      },
      !src && React.createElement(
        'div',
        { className: classes.avatarText },
        React.createElement(
          Typography,
          { type: 'display1' },
          children
        )
      )
    )
  );
};

ImageAvatars.propTypes = {
  classes: PropTypes.object.isRequired,
  children: PropTypes.any,
  src: PropTypes.string.isRequired,
  alt: PropTypes.string,
  size: PropTypes.any
};

ImageAvatars.defaultProps = {
  src: '',
  alt: '',
  size: 60
};

export default withStyles(styleSheet)(ImageAvatars);