var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import Sidebar from 'react-sidebar';
import AppBar from 'material-ui/AppBar';
import ImageAvatar from './ImageAvatar';
import { withStyles, createStyleSheet } from 'material-ui/styles';
import Toolbar from 'material-ui/Toolbar';
import Typography from 'material-ui/Typography';
import Button from 'material-ui/Button';
import IconButton from 'material-ui/IconButton';
import MenuIcon from 'material-ui-icons/Menu';
import { Container, Row, Col, Visible, Hidden, ScreenClassRender } from './Grid';

var LARGE_SCREEN_WIDTH = 933;

var styleSheet = createStyleSheet({
  NavigationSideBar: {
    width: 290
  },
  flex: {
    flex: 1
  },
  backgroundCover: {
    backgroundRepeat: 'no-repeat',
    backgroundPosition: 'center'
  },
  avatarInfo: {
    color: '#ffffff',
    background: 'rgba(0, 0, 0, 0.3)',
    paddingTop: 8,
    paddingBottom: 8
  },
  avatarImage: {
    paddingTop: 16,
    paddingBottom: 16
  }
});

var Navigation = function (_PureComponent) {
  _inherits(Navigation, _PureComponent);

  function Navigation(props) {
    _classCallCheck(this, Navigation);

    var _this = _possibleConstructorReturn(this, (Navigation.__proto__ || Object.getPrototypeOf(Navigation)).call(this, props));

    _this.handleToggle = function () {
      return _this.setState({ isOpen: !_this.state.isOpen });
    };

    var isLargeScreen = screen.width >= LARGE_SCREEN_WIDTH;

    _this.state = {
      isLargeScreen: isLargeScreen,
      isOpen: isLargeScreen,
      width: 0
    };
    return _this;
  }

  _createClass(Navigation, [{
    key: 'render',


    // utilizar metodos abaixo caso queira controlar onResize
    // componentWillMount() {
    //   this.updateDimensions();
    // }
    // componentDidMount() {
    //   window.addEventListener('resize', this.updateDimensions);
    // }
    //
    // componentWillUnmount() {
    //   window.removeEventListener('resize', this.updateDimensions);
    // }
    //
    // updateDimensions() {
    //   console.log('loucura loucura', screen.width);
    //   // this.setState({ width: screen.width });
    // }

    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          topMenuTitle = _props.topMenuTitle,
          sideMenu = _props.sideMenu,
          avatarImg = _props.avatarImg,
          avatarTitle = _props.avatarTitle,
          avatarSubTitle = _props.avatarSubTitle,
          sideMenuHeaderBg = _props.sideMenuHeaderBg,
          sideMenuFooter = _props.sideMenuFooter,
          classes = _props.classes;
      var _state = this.state,
          isOpen = _state.isOpen,
          isLargeScreen = _state.isLargeScreen;


      return React.createElement(
        'div',
        { className: 'Navigation' },
        React.createElement(
          Sidebar,
          {
            sidebar: React.createElement(
              'div',
              { className: classes.NavigationSideBar },
              React.createElement(
                'div',
                {
                  className: classes.backgroundCover,
                  style: { backgroundImage: 'url(' + sideMenuHeaderBg + ')' }
                },
                React.createElement(
                  Container,
                  { className: classes.avatarImage },
                  React.createElement(
                    Row,
                    null,
                    React.createElement(
                      Col,
                      { xs: 12 },
                      React.createElement(
                        ImageAvatar,
                        { src: avatarImg },
                        'U'
                      )
                    )
                  )
                ),
                React.createElement(
                  Container,
                  { className: classes.avatarInfo },
                  React.createElement(
                    Row,
                    null,
                    React.createElement(
                      Col,
                      { xs: 12 },
                      React.createElement(
                        Typography,
                        { type: 'body1', style: { color: '#ffffff' } },
                        avatarTitle,
                        React.createElement('br', null),
                        avatarSubTitle
                      )
                    )
                  )
                )
              ),
              React.createElement(
                'div',
                null,
                sideMenu
              ),
              React.createElement(
                'div',
                { style: { position: 'absolute', bottom: 0, width: '100%' } },
                React.createElement(
                  'div',
                  { style: { width: '100%', textAlign: 'right' } },
                  sideMenuFooter
                )
              )
            ),
            docked: isLargeScreen && isOpen,
            sidebarClassName: 'NavigationSideBar',
            open: isOpen,
            onSetOpen: function onSetOpen(state) {
              return _this2.setState({ isOpen: state });
            }
          },
          React.createElement(
            'div',
            { className: 'NavigationTopBar' },
            React.createElement(
              AppBar,
              { position: 'static' },
              React.createElement(
                Toolbar,
                null,
                React.createElement(
                  IconButton,
                  { onClick: this.handleToggle, color: 'contrast', 'aria-label': 'Menu' },
                  React.createElement(MenuIcon, null)
                ),
                React.createElement(
                  Typography,
                  { type: 'title', color: 'inherit', className: classes.flex },
                  topMenuTitle
                ),
                React.createElement(
                  Button,
                  { color: 'contrast' },
                  'Login'
                )
              )
            )
          ),
          React.createElement(
            'div',
            { className: 'NavigationContent' },
            children
          )
        )
      );
    }
  }]);

  return Navigation;
}(PureComponent);

Navigation.propTypes = {
  classes: PropTypes.object.isRequired,
  children: PropTypes.element,
  showNavigation: PropTypes.bool,
  sideMenu: PropTypes.any,
  topMenuTitle: PropTypes.any,
  sideMenuTitle: PropTypes.any,
  sideMenuFooter: PropTypes.any,
  sideMenuHeaderBg: PropTypes.string,
  avatarImg: PropTypes.string,
  avatarTitle: PropTypes.string,
  avatarSubTitle: PropTypes.string
};

Navigation.defaultProps = {
  children: null,
  showNavigation: false,
  topMenuTitle: '',
  sideMenuTitle: '',
  sideMenuFooter: null,
  sideMenu: null,
  sideMenuHeaderBg: '',
  avatarImg: '',
  avatarTitle: '',
  avatarSubTitle: ''
};

export default withStyles(styleSheet)(Navigation);